﻿using System.Collections.Generic;
using PAT.Common.Classes.Assertion;
using PAT.Common.Classes.Expressions;
using PAT.Common.Classes.LTS;
using PAT.Common.Classes.Ultility;
using PAT.SCSP.LTS;

namespace PAT.SCSP.Assertions{
    public partial class SCSPAssertionReachability : AssertionReachability
    {
        private DefinitionRef Process;

        public SCSPAssertionReachability(DefinitionRef processDef, string reachableState) : base(reachableState)
        {
            Process = processDef;
        }

        public override string StartingProcess
        {
            get
            {
                return Process.ToString();
            }
        }

        public override void Initialize(SpecificationBase spec)
        {
            Specification Spec = spec as Specification;
            ReachableStateCondition = Spec.DeclarationDatabase[ReachableStateLabel];
                                    
            Valuation GlobalEnv = Spec.SpecValuation;
            
            //Initialize InitialStep
            InitialStep = new Configuration(Process, Constants.INITIAL_EVENT, GlobalEnv, false);

            MustAbstract = Process.MustBeAbstracted();
        }
        
        //todo: override ToString method if your assertion uses different syntax as PAT
        //public override string ToString()
        //{
        //		return "";
        //}        
    }
}