﻿using System.Collections.Generic;
using System.Text;
using PAT.Common.Classes.Expressions;
using PAT.Common.Classes.Expressions.ExpressionClass;
using PAT.Common.Classes.LTS;
using PAT.Common.Classes.Ultility;
using PAT.SCSP.Assertions;

namespace PAT.SCSP.LTS{
    public sealed class EventPrefix : Process
    {
        public string Event;
        public Process Process;
        
        public EventPrefix(string e, Process process)
        {
            Event = e;
            Process = process;
            ProcessID = DataStore.DataManager.InitializeProcessID(Event + Constants.EVENTPREFIX + Process.ProcessID);
        }

        public override void MoveOneStep(Valuation GlobalEnv, List<Configuration> list)
        {
            System.Diagnostics.Debug.Assert(list.Count == 0);

            list.Add(new Configuration(Process, Event, GlobalEnv, false));
        }

        public override string ToString()
        {
            return "(" + Event + "->" + Process.ToString() + ")";
        }

        //public override HashSet<string> GetAlphabets(Dictionary<string, string> visitedDefinitionRefs)
        //{
        //    HashSet<string> list = Process.GetAlphabets(visitedDefinitionRefs);

        //    if (Specification.CollectDataOperationEvent == null)
        //    {
        //        if (Event.ExpressionList != null)
        //        {
        //            foreach (Expression expression in Event.ExpressionList)
        //            {
        //                if (expression.HasVar)
        //                {
        //                    StringBuilder sb = new StringBuilder();
        //                    sb.AppendLine("ERROR - PAT FAILED to calculate the alphabet.");
        //                    sb.AppendLine("CAUSE - Event " + Event + " contains global variables!");
        //                    sb.AppendLine(
        //                        "REMEDY - 1) Avoid using global variables in events 2) Or manually specify the alphabet of the relevant process using the following syntax: \n\r\t #alphabet someProcess {X}; \n\rwhere X is a set of event names.");
        //                    throw new RuntimeException(sb.ToString());
        //                }
        //            }
        //        }

        //        string name = Event.GetEventID(null);

        //        if (name != Constants.TAU && !list.Contains(name))
        //        {
        //            list.Add(name);
        //        }
        //    }
        //    else if (Specification.CollectDataOperationEvent == false && Event.ToString() != Constants.TAU)
        //    {
        //        HashSet<string> set = Process.GetAlphabets(visitedDefinitionRefs);
        //        set.Add(Event.BaseName);

        //        return set;
        //    }
        //    return list;
        //}

        //public override List<string> GetChannels()
        //{
        //    return Process.GetChannels();
        //}

        public override bool MustBeAbstracted()
        {
            return Process.MustBeAbstracted();
        }

        public override bool IsBDDEncodable()
        {
            return Process.IsBDDEncodable();
        }
    }
}